#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#include <string>
#include "Disposable.h"

namespace Inter4ql {
	/** @brief class that implements an exception
	 *
	 */
	class Exception {
	public:
		/** @brief standard constructor that sets exception value
		 *
		 * @param arg_name value of an exception
		 */
		Exception(std::string arg_name, Inter4ql::Disposable* toDelete = 0);
		/** @brief destructor
		 */
		~Exception();
		/** @brief getter for exception value
		 *
		 * @return value of an exception
		 */
		std::string get();
		/** @brief getter for values to delete
		 *
		 * @return pointer to Disposable object
		 */
		Inter4ql::Disposable* getDisp();
		/** @brief setter for exception value
		 *
		 * @param _name value of an exception
		 */
		void set(std::string _name);
	private:
		Inter4ql::Disposable* toDelete;
		std::string name;
	};
}

#endif
