#ifndef __EXPRESSSION_H__
#define __EXPRESSSION_H__

#include "Fact.h"
#include "Relation.h"

namespace Inter4ql {
	class ConstraintEntry;

	class Expression {
	public:
		Expression(expression_type::type type, Expression* lexpr, Expression* rexpr, Fact* term);
		Expression(expression_type::type type, Expression* lexpr, Expression* rexpr, Expression* elseexpr = nullptr);
		Expression(ConstraintEntry* qe);
		~Expression();
		expression_type::type get_type();
		Expression* get_left_expression();
		Expression* get_right_expression();
		Expression* get_else_expression();
		Fact* get_term();
		std::string get_action_name();
		ConstraintEntry* get_quantified_entry();
		void set_module(std::string s);
		std::string get_module();
		void set_delete_term(bool value);
		bool is_simple_relation();
		void set_simple_relation_flag(bool value);
	private:
		expression_type::type my_type;
		Expression* my_lexpr;
		Expression* my_rexpr;
		Expression* my_elseexpr;
		Fact* my_term;
		ConstraintEntry* my_quantified_entry;
		std::string module;
		bool should_delete_term;
		bool simple_relation_flag;
	};
}

#endif
