#ifndef __MODULESUM_H__
#define __MODULESUM_H__

#include "ModuleLocal.h"

#include "ModuleGeneric.h"

namespace Inter4ql {
	/** @brief Implementation of ModuleSum for sum of module models
	 */
	class ModuleSum : public ModuleLocal {
	public:
		/** @brief constructor
		 *
		 * @param a_name name of a module
		 */
		ModuleSum();
		/** @brief destructor
		 *
		 */
		~ModuleSum();

		/** @brief adds module to the sum
		 *
		 */
		void add_module(ModuleGeneric* m);

		/** @brief fetches a database of facts from well-supported model (for summing purposes)
		 *
		 * @return database of wsm facts
		 */
		Inter4ql::database* get_wsm_database() override { return &database_; }
	};
}

#endif  /* __MODULESUM_H__ */

