#ifndef __PARSER_H__
#define __PARSER_H__

#include <fstream>
#include <iterator>
#include <string>

#include "LineParser.tab.h"

namespace Inter4ql {

	class Output;
	class Exception;
	class Scanner;
	class Functions;

	/** @brief Parser class, enclosure of generated GNU Bison LineParser class.
	 */
	class Parser {
	public:
		/** @brief constructor
		 *
		 * @param _o default output we want to write
		 * @param arg_yyin input we want to read from
		 * @param aarg_yyout output we want to bison write to
		 */
		Parser(Inter4ql::Output *_o, std::istream* arg_yyin = 0, std::ostream* aarg_yyout = 0);
		/** @brief destructor
		 */
		~Parser();
		/** @brief initalize of a parser
		 *
		 * @param arg_yyin input we want to read from
		 * @param aarg_yyout output we want to bison write to
		 */
		void init(std::istream* arg_yyin = 0, std::ostream* aarg_yyout = 0);
		/** @brief parsing method
		 *
		 * @return parsed line from command line
		 */
		Inter4ql::parser_line *parse();
	private:
		Inter4ql::parser_line line;
		Inter4ql::Output *output;
		Inter4ql::Scanner *scanner;
		Inter4ql::LineParser *parser;

	};
}

#endif
