#ifndef MATH_H
#define MATH_H

#include "../ModuleInternal.h"

namespace Inter4ql {

    class VariableSpace;

    /** @brief Math module used to implement basic math operations
     */
    class Math : public ModuleInternal {
    public:
		/** @brief constructor for Math module
		 *
		 * @param _v pointer to VariableSpace class
		 */
		explicit Math(VariableSpace *_v);

		/** @brief Function executing math function
		 *
		 * @param relation name of relation to execute
		 * @param bindedValues list of params for application
		 * @return TRUE or FALSE
		 */
		static Inter4ql::logic_type::type runPlugin(std::string relation, std::vector<Value*>* bindedValues);

		void reason();
		Result ask_for_result(Fact * term) const;
    private:
        void add_relation(std::string name, std::string interface);
    };
}

#endif  /* MATH_H */

