#include "VariableSpace.h"
#include "Value.h"
#include "Exception.h"

#include <iostream>
#include <string>
#include <cstdlib>
int testnum = 0;

void ok(){
	testnum++;
	std::cout << testnum << ": OK!\n";
}

void fail(){
	testnum++;
	std::cout << testnum << ": FAIL\n";
	exit(0);
}

using namespace Inter4ql;

int main(){
try{
	std::cout << "Starting tests:\n";
	bool did_change;
	// test 1: wrzucenie paru wartosci do puli integer
	VariableSpace *s = new VariableSpace();
	Value *v = new Value(5);
	Value *v1 = s->get_pointer(v, "test", "integer", did_change);
	Value *v2 = s->get_pointer(v, "test", "integer", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_integer_space("test", "integer")->size() != 1)
		fail(); else ok();
	s->get_pointer(new Value(6), "test", "integer", did_change);
	v1 = s->get_pointer(new Value(6), "test", "integer", did_change);
	v2 = s->get_pointer(new Value(6), "test", "integer", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_integer_space("test", "integer")->size() != 2)
		fail(); else ok();
	v2 = s->get_pointer(v1, "test", "integer", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_integer_space("test", "integer")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(v2, "test", "integer", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_integer_space("test", "integer")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(new Value(7), "test", "integer", did_change);
	if(v1 == v2)
		fail(); else ok();
	if(s->get_integer_space("test", "integer")->size() != 3)
		fail(); else ok();
	// testy dalej, wersja dla literalow 11
	v = new Value("a");
	v1 = s->get_pointer(v, "test", "literal", did_change);
	v2 = s->get_pointer(v, "test", "literal", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_const_space("test", "literal")->size() != 1)
		fail(); else ok();
	s->get_pointer(new Value("b"), "test", "literal", did_change);
	v1 = s->get_pointer(new Value("b"), "test", "literal", did_change);
	v2 = s->get_pointer(new Value("b"), "test", "literal", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_const_space("test", "literal")->size() != 2)
		fail(); else ok();
	v2 = s->get_pointer(v1, "test", "literal", did_change);	
	if(v1 != v2)
		fail(); else ok();
	if(s->get_const_space("test", "literal")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(v2, "test", "literal", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_const_space("test", "literal")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(new Value("c"), "test", "literal", did_change);
	if(v1 == v2)
		fail(); else ok();
	if(s->get_const_space("test", "literal")->size() != 3)
		fail(); else ok();
	// testy dalej, wersja dla napisow 21
	v = new Value("\"a\"");
	v1 = s->get_pointer(v, "test", "string", did_change);
	v2 = s->get_pointer(v, "test", "string", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_string_space("test", "string")->size() != 1)
		fail(); else ok();
	s->get_pointer(new Value("\"b\""), "test", "string", did_change);
	v1 = s->get_pointer(new Value("\"b\""), "test", "string", did_change);
	v2 = s->get_pointer(new Value("\"b\""), "test", "string", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_string_space("test", "string")->size() != 2)
		fail(); else ok();
	v2 = s->get_pointer(v1, "test", "string", did_change);	
	if(v1 != v2)
		fail(); else ok();
	if(s->get_string_space("test", "string")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(v2, "test", "string", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_string_space("test", "string")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(new Value("\"c\""), "test", "string", did_change);
	if(v1 == v2)
		fail(); else ok();
	if(s->get_string_space("test", "string")->size() != 3)
		fail(); else ok();
	// testy dalej, wersja dla dat 31
	v = new Value("2010-05-20");
	v1 = s->get_pointer(v, "test", "date", did_change);
	v2 = s->get_pointer(v, "test", "date", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_date_space("test", "date")->size() != 1)
		fail(); else ok();
	s->get_pointer(new Value("1999-01-01"), "test", "date", did_change);
	v1 = s->get_pointer(new Value("1999-01-01"), "test", "date", did_change);
	v2 = s->get_pointer(new Value("1999-01-01"), "test", "date", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_date_space("test", "date")->size() != 2)
		fail(); else ok();
	v2 = s->get_pointer(v1, "test", "date", did_change);	
	if(v1 != v2)
		fail(); else ok();
	if(s->get_date_space("test", "date")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(v2, "test", "date", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_date_space("test", "date")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(new Value("2003-01-01"), "test", "date", did_change);
	if(v1 == v2)
		fail(); else ok();
	if(s->get_date_space("test", "date")->size() != 3)
		fail(); else ok();
	// testy dalej, wersja dla dat z czasem 41
	v = new Value("2010-05-20 15:30");
	v1 = s->get_pointer(v, "test", "datetime", did_change);
	v2 = s->get_pointer(v, "test", "datetime", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_datetime_space("test", "datetime")->size() != 1)
		fail(); else ok();
	s->get_pointer(new Value("1999-01-01 15:30"), "test", "datetime", did_change);
	v1 = s->get_pointer(new Value("1999-01-01 15:30"), "test", "datetime", did_change);
	v2 = s->get_pointer(new Value("1999-01-01 15:30"), "test", "datetime", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_datetime_space("test", "datetime")->size() != 2)
		fail(); else ok();
	v2 = s->get_pointer(v1, "test", "datetime", did_change);	
	if(v1 != v2)
		fail(); else ok();
	if(s->get_datetime_space("test", "datetime")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(v2, "test", "datetime", did_change);
	if(v1 != v2)
		fail(); else ok();
	if(s->get_datetime_space("test", "datetime")->size() != 2)
		fail(); else ok();
	v1 = s->get_pointer(new Value("2003-01-01 15:30"), "test", "datetime", did_change);
	if(v1 == v2)
		fail(); else ok();
	if(s->get_datetime_space("test", "datetime")->size() != 3)
		fail(); else ok();
	
} catch(Exception *e){
	std::cout << e->get() << "\n";
}
	return 0;
}
